#ifndef	XPANEL_DBUS_PUBLIC_H
#define	XPANEL_DBUS_PUBLIC_H

#include <glib.h>

typedef int (*dhcp_setter_t)(void *context, const char *interface);

GList *get_interface_names(void *context);
void free_interface_names(void *context, GList *list);
gboolean get_interface_settings(void *context, const char *netinterface, char **ipaddr, char **netmask);
gboolean apply_manualnet_update(void *context, const char *default_gtw, const char *dns1, const char *dns2,
								const char **interfaces);
GList * get_rps_devices(void *context);
gboolean get_rps_mask(void *context, char * device, gint *ps_mask);
gboolean get_rps_voltage(void *context, char * device, int *ps_voltage);
gboolean get_twinstar_status(void *context, char **drbd_role, char **drbd_cs);
gboolean get_num_calls(void *context, char **num_calls);
gboolean blink_ports(void *context, char *type, char *value);

int asterisk_restart(void *context);
int dahdi_restart(void *context);
int server_reboot(void *context);
int server_poweroff(void *context);								
gboolean get_fan_speed(void *context, guchar *fan0, guchar *fan1, guchar *fan2);
gboolean psu_status_notification(void *context, guchar sts, guchar *action); 
gboolean get_raid_status(void *context, char **raid_sts);

struct network_settings {
	char		*defaultgw;
	char		*dns1;
	char		*dns2;
	char		**raw_data;
};

int dhcp_setter(void *context, const char *netinterface);
void free_network_settings(void *data, struct network_settings *netsettings);
gboolean get_network_settings(void *data, struct network_settings *netsettings);
#endif	/* XPANEL_DBUS_PUBLIC_H */
