#ifndef	XPANEL_DBUS_H
#define	XPANEL_DBUS_H

#include <xpanel/xpw.h>
#include <xpanel/xpw_background.h>

G_BEGIN_DECLS

#define XPANEL_TYPE_DAEMON         (xpanel_daemon_get_type ())
#define XPANEL_DAEMON(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), XPANEL_TYPE_DAEMON, XPanelDaemon))
#define XPANEL_DAEMON_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), XPANEL_TYPE_DAEMON, XPanelDaemonClass))
#define XPANEL_IS_DAEMON(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), XPANEL_TYPE_DAEMON))
#define XPANEL_IS_DAEMON_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), XPANEL_TYPE_DAEMON))
#define XPANEL_DAEMON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), XPANEL_TYPE_DAEMON, XPanelDaemonClass))

typedef void (*raid_sts_cb_t)(const char *interface);

typedef struct XPanelDaemonPrivate XPanelDaemonPrivate;

typedef struct {
	GObject parent;
	XPanelDaemonPrivate        *priv;
} XPanelDaemon;

typedef struct {
	GObjectClass             parent_class;
} XPanelDaemonClass;

typedef enum {
	XPANEL_DAEMON_ERROR_GENERAL,
	XPANEL_DAEMON_ERROR_NOT_SUPPORTED,
	XPANEL_DAEMON_ERROR_NO_SUCH_DEVICE,
	XPANEL_DAEMON_NUM_ERRORS
} XPanelDaemonError;


#define	XPANEL_DAEMON_ERROR		(xpanel_daemon_error_quark ())
#define	XPANEL_DAEMON_TYPE_ERROR	(xpanel_daemon_error_get_type ())

GQuark	xpanel_daemon_error_quark	(void);
GType	xpanel_daemon_error_get_type	(void);

gboolean xpanel_daemon_dbus_register(XPanelDaemon *daemon);
// XPanelDaemon *xpanel_daemon_new(struct xpw_screen *screen, struct xpw_background *background);
XPanelDaemon *xpanel_daemon_new(struct xpw_screen *screen, struct xpw_background *background, raid_sts_cb_t raid_sts_cb);

int set_network_parameters(
	const char *str_ipaddr,
	const char *str_netmask,
	const char *str_defaultgw,
	const char *str_dns1,
	const char *str_dns2,
	void *data);

G_END_DECLS

#endif	/* XPANEL_DBUS_H */
