#ifndef	XPW_SETUP_H
#define	XPW_SETUP_H

#include <glib.h>
#include <xpanel/xpw_menu.h>
#include <xpanel/kbd_glib.h>
#include <xpanel-dbus-public.h>

struct xpanel_ui {
	void			*user_data; // pointer to XPanelDaemon
	struct xpw		*toplevel;
	GList			*netif_names;
	struct network_settings	network_settings;
	dhcp_setter_t		dhcp_setter;
	const char		*login_name;
	int			screen_lock_is_active;
	int			screen_lock_password_active;
	int			screen_lock_time;
	int			screen_lock_facade;
	int			psu_check_time;
	int			psu_last_sts;
	gboolean	lcd_flashing_sts;
	gboolean	psu_failure_detected;
	gboolean	raid_failure_detected;
	char		psu_failure_txt[XPW_DISPLAYBOX_MAXWIDTH];
	char		raid_failure_txt[XPW_DISPLAYBOX_MAXWIDTH];
	struct pcp_device	*pcpdev;
	struct xpw_screen	*screen;
};

//void xpw_set_netnotify(widget_notify_t netnotify, void *data);
void xpw_set_dhclient(widget_notify_t netnotify, void *data);
gboolean get_fan_speed_ui(guchar *fan0, guchar *fan1, guchar *fan2); 
gboolean psu_check_timeout_cb(void *data);
void stop_flashing();
void raid_sts_cb(const char *txt);

struct xpanel_ui *xpanel_ui_new(struct pcp_device *pcpdev, struct xpw_screen *screen,
								 int lock_time, int psu_time,
								 const char *login_name, const char *logo);
void xpanel_ui_bind(struct xpanel_ui *ui, void *data);
void xpanel_ui_destroy(struct xpanel_ui *ui);
int xpanel_kbd_idle(struct xpanel_kbd *kbd, void *data);
int screen_lock(struct xpanel_ui *ui);
int screen_unlock(struct xpanel_ui *ui);

#endif	/* XPW_SETUP_H */
